/*
 * led.h
 *
 *  Created on: 4 . 2016 .
 *      Author: mvinogradov
 */
#include <avr/io.h>
#include <avr_helper.h>

#ifndef LED_H_
#define LED_H_

// ERROR or Collision LED
///     (   )
#define LED1_PORT		D
///  f   
#define LED1_PIN		5

//  
#define led1_on() PORT(LED1_PORT) |= _BV(LED1_PIN)
//  
#define led1_off() PORT(LED1_PORT) &= ~_BV(LED1_PIN)

// Work  LED
///     (   )
#define LED2_PORT		D
///  f   
#define LED2_PIN		6

//  
#define led2_on() PORT(LED2_PORT) |= _BV(LED2_PIN)
//  
#define led2_off() PORT(LED2_PORT) &= ~_BV(LED2_PIN)

// 
///   (   )
#define headlamp_PORT		C
///    
#define headlamp_PIN		4

//  
#define headlamp_on() PORT(headlamp_PORT) |= _BV(headlamp_PIN)
//  
#define headlamp_off() PORT(headlamp_PORT) &= ~_BV(headlamp_PIN)
//  
#define headlamp_invert() PORT(headlamp_PORT) ^= _BV(headlamp_PIN)

//  ()
///   (   )
#define BUZZER_PORT		C
///    
#define BUZZER_PIN		5

// 
#define buzzer_on() PORT(BUZZER_PORT) |= _BV(BUZZER_PIN)
//  
#define buzzer_off() PORT(BUZZER_PORT) &= ~_BV(BUZZER_PIN)
//  
#define buzzer_invert() PORT(BUZZER_PORT) ^= _BV(BUZZER_PIN)

//  1
///   (   )
#define BLINK1_PORT		D
///    
#define BLINK1_PIN		2

// 
#define blink1_on() PORT(BLINK1_PORT) |= _BV(BLINK1_PIN)
// 
#define blink1_off() PORT(BLINK1_PORT) &= ~_BV(BLINK1_PIN)
//  
#define blink1_invert() PORT(BLINK1_PORT) ^= _BV(BLINK1_PIN)

//  2
///   (   )
#define BLINK2_PORT		D
///    
#define BLINK2_PIN		3

// 
#define blink2_on() PORT(BLINK2_PORT) |= _BV(BLINK2_PIN)
// 
#define blink2_off() PORT(BLINK2_PORT) &= ~_BV(BLINK2_PIN)
//  
#define blink2_invert() PORT(BLINK2_PORT) ^= _BV(BLINK2_PIN)


extern void led_init(void);

#endif /* LED_H_ */
