/*********************************************

   
 : Version: Neon.1 Release (4.6.1) Build id: 20160913-0900, WinAVR 20100110
:
1.     USART   9600   
2.   , ,   5   
3.      3

Device: atmega8L

Program:    4974 bytes (60.7% Full)
(.text + .data + .bootloader)

Data:         80 bytes (7.8% Full)
(.data + .bss + .noinit)

EEPROM:        9 bytes (1.8% Full)
(.eeprom)


Finished building: sizedummy

Linker argument: -Wl,-gc-sections
Compiller argument: -ffunction-sections

 H-  : http://www.openservo.com/Schematic2?action=AttachFile&do=view&target=openservo_2.1_schematic.pdf

 *********************************************/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include "avr_helper.h"
#include <util/delay.h>
#include "protocol.h"
#include "executor.h"
#include "config.h"
#include "led.h"
#include "timer.h"
#include <stdio.h>
#include "adc.h"
#include "buttons.h"
#include <avr/sleep.h>
#include <avr/wdt.h>
#include "mirf.h"
#include "nRF24L01.h"
#include "com_io.h"
#include "motor.h"

//static uint8_t cmd_buf[32];			//    

SIGNAL(INT0_vect)
{
   // ISR might be empty, but is necessary nonetheless
	led1_on();
    // disable external interrupt here, in case the external low pulse is too long
    //GICR &= ~(1 << INT0);
}

int main(void){
	//static uint8_t cmd_len;							//    

	//      
	#define CMD_BUF_SZ 32
	static uint8_t cmd_buf[CMD_BUF_SZ];			//    
	static int8_t debug_temp_res,low_power_flag;				//           
	static buttons_t cmd;						//       (  )

        //   
        //timer0_init();
	    motor_init();
    	//key_init();
    	led_init();
    	//timer2_init();							//     


        load_config(&config);						//   
        config.debug_on=ON;
        led_init();
		timer1_init();
		adc_init();
		pwm_duty=120;
		timer0_init();								//        -

 /*
		// level interrupt INT0 (low level)
		MCUCR &= ~((1 << ISC01) | (1 << ISC00));
}*/
		mirf_init();									//      NRF (, spi)
		_delay_ms(50);									//  

		//blink1_invert();
		headlamp_on();
		led1_on();
		led2_on();
		_delay_ms(100);
		headlamp_off();
		//blink1_invert();
		led1_off();
		led2_off();
		//_delay_ms(2000);

        printf_P(PSTR("START\r"));
		printf_P(PSTR("NRF config "));
		debug_temp_res=mirf_config();
		if (debug_temp_res==1){							//   NRF (, ,   ..)
			led2_on();
			printf_P(PSTR("OK\r"));
			led2_off();
		}else{
			led1_on();
			printf_P(PSTR("ERROR=%d\r"),debug_temp_res);
			led1_off();
		}

		nrf_print_status();
		nrf_print_config();
		nrf_print_setup();
		nrf_print_future();
		printf_P(PSTR("CD=%d\r"), mirf_read_register(CD));
		printf_P(PSTR("CHANEL=%d\r"), mirf_read_register(RF_CH));
		printf_P(PSTR("L_PAYLOAD=%d\r"), mirf_read_register(RX_PW_P0));
		low_power_flag=0;

		sei(); // interrupt on, clock starts ticking now

        while(1){
        	//      
        	if (time_is_over(DELAY_REPEAT)){
        		//   
        		if (get_battery_low()){
        			//  , 
        			stop();
        			center();
        			buzzer_on();
        			printf_P(PSTR("battery voltage=%04d\r"),get_battery_voltage());
        			buzzer_off();
        			_delay_ms(500);
        			buzzer_on();
        			_delay_ms(500);
        			buzzer_off();
        			reset_timer(DELAY_REPEAT);
        			low_power_flag=1;
        		}else {
        			low_power_flag=0;
        		}
        	}
        	if (time_is_over(DELAY_POWERDOWN)){
        		//      
        		headlamp_off();
        		timer2_stop();
        		stop();
        		center();
        		led1_off();
        		led2_off();
        		buzzer_off();
        		reset_timer(DELAY_POWERDOWN);
        		printf_P(PSTR("DELAY_POWERDOWN\r"));
        	}
        	if (mirf_get_status()&(1<<RX_DR)) {
        	    			//    NRF,  
        	    			led2_on();
        	    			//printf_P(PSTR("battery voltage=%04d\r"),get_battery_voltage());
        	    			reset_timer(DELAY_POWERDOWN);
        	    			printf_P(PSTR("RX_DR\r"));
        	    			char rx_len=0;
        	    			rx_len=radio_read_rx_payload_width();
        	    			printf_P(PSTR("rx len=%02d\r"),rx_len);
        	    			if (rx_len>1){
        	    				//    ,  
        	    				spi_writeread(FLUSH_RX);	//    
        	    				printf_P(PSTR("bad package\r"));
        	    			}else{
        	    			//mirf_read(cmd_buf);										//    
        	    			mirf_read_buf(cmd_buf,rx_len);								//    
        	    			_delay_ms(10);												//   
/*        	    			//     
        	    			for (uint8_t i=0;i<rx_len;i++){
        	    				printf_P(PSTR("%02d"),cmd_buf[i]);
        	    			}
        	    			printf_P(PSTR("\r"));*/

        	    			cmd.byte=cmd_buf[0];
        	    			 printf_P(PSTR("KEY\t\t = %02d BACKRWARD=%x LEFT=%x RIGHT=%x BOOZ=%x BLINK=%x LAMP=%x FORWARD=%x\r"),
        	    					 cmd.byte,
									 cmd.k_back,
									 cmd.k_left,
									 cmd.k_right,
									 cmd.k_booz,
									 cmd.k_blink,
									 cmd.k_lamp,
									 cmd.k_fwd
        	    			          );
        	    			 if (low_power_flag) {
        	    				 led2_off();
        	    				 printf_P(PSTR("low_power_flag\r"));
        	    				 continue;	//   ,        
        	    			 }

        	    			 //       
        	    			 if (cmd.k_booz){
        	    				 buzzer_on();
        	    				 printf_P(PSTR("boozer on\r"));
        	    			 }else{
        	    				 buzzer_off();
        	    				 printf_P(PSTR("boozer off\r"));
        	    			 }

        	    			 //printf_P(PSTR("1\r"));
        	    			 if (cmd.k_fwd){
        	    				 forward();
        	    				 printf_P(PSTR("forward\r"));
        	    			 }else if (cmd.k_back){
        	    				 backward();
        	    				 printf_P(PSTR("backward\r"));
        	    			 }else{
        	    				 stop();
        	    				 printf_P(PSTR("stop\r"));
        	    			 }
        	    			 //printf_P(PSTR("2\r"));

        	    			 if (cmd.k_left){
        	    				 left();
        	    				 printf_P(PSTR("left\r"));
        	    			 }else if (cmd.k_right){
        	    				 right();
        	    				 printf_P(PSTR("right\r"));
        	    			 }else {
        	    				 center();
        	    				 printf_P(PSTR("center\r"));
        	    			 }

        	    			 if (cmd.k_blink){
        	    				 if (TCCR2){
        	    					 timer2_stop();
        	    					 printf_P(PSTR("blink on\r"));
        	    				 }else{
        	    					 timer2_init();
        	    					 printf_P(PSTR("blink off\r"));
        	    				 }
        	    			 }

        	    			 if (cmd.k_lamp){
        	    				 headlamp_invert();
        	    				 printf_P(PSTR("headlamp_invert\r"));
        	    			 }

        	    			 //   
        	    			 if (cmd.k_blink && cmd.k_booz && cmd.k_lamp){
        	    				 if (pwm_duty!=120){
            	    				 //  
        	    					 pwm_duty=250;
        	    					 printf_P(PSTR("turbo on\r"));
        	    				 }else{
            	    				 //  
            	    				 pwm_duty=120;
            	    				 printf_P(PSTR("turbo off\r"));
        	    				 }
            	    			buzzer_on();
            	    	        _delay_ms(100);
            	    	        buzzer_off();
            	    	      	buzzer_on();
            	    	        _delay_ms(100);
            	    	        buzzer_off();
            	    	        _delay_ms(1000);
        	    			 }
        	    			led2_off();

        	    			}
        	    		}

    		}
}
