/*
 * motor.h
 *
 *  Created on: 1 . 2016 .
 *      Author: Mike_home
 */

#ifndef MOTOR_H_
#define MOTOR_H_


#define DEADTIME_US_DELAY		100

//      (   H-)
// DC POWER MOTOR 1- FORWARD, 2-BACKWARD
///    (   )
#define DRIVE1_PORT		C
///    
#define DRIVE1_PIN		0

///    (   )
#define DRIVE2_PORT		D
///    
#define DRIVE2_PIN		4

// DC SERVO MOTOR 1- LEFT, 2-RIGHT
///    (   )
#define DRIVE3_PORT		C
///    
#define DRIVE3_PIN		2

///    (   )
#define DRIVE4_PORT		C
///    
#define DRIVE4_PIN		3

//   
//   
#define forward() PORT(DRIVE2_PORT) &= ~_BV(DRIVE2_PIN); \
					_delay_us(DEADTIME_US_DELAY);\
					PORT(DRIVE1_PORT) |= _BV(DRIVE1_PIN)
//  
#define backward() PORT(DRIVE1_PORT) &= ~_BV(DRIVE1_PIN); \
					_delay_us(DEADTIME_US_DELAY);\
					PORT(DRIVE2_PORT) |= _BV(DRIVE2_PIN)
// 
#define stop() PORT(DRIVE1_PORT) &= ~_BV(DRIVE1_PIN); \
					_delay_us(DEADTIME_US_DELAY);\
					PORT(DRIVE2_PORT) &= ~_BV(DRIVE2_PIN)

//   
#define left() PORT(DRIVE3_PORT) |= _BV(DRIVE3_PIN); \
					_delay_us(DEADTIME_US_DELAY);\
					PORT(DRIVE4_PORT) &= ~_BV(DRIVE4_PIN)
//   
#define right() PORT(DRIVE3_PORT) &= ~_BV(DRIVE3_PIN); \
					_delay_us(DEADTIME_US_DELAY);\
					PORT(DRIVE4_PORT) |= _BV(DRIVE4_PIN)
//    
#define center() PORT(DRIVE3_PORT) &= ~_BV(DRIVE3_PIN); \
					_delay_us(DEADTIME_US_DELAY);\
					PORT(DRIVE4_PORT) &= ~_BV(DRIVE4_PIN)

extern void motor_init(void);

#endif /* MOTOR_H_ */
